Attribute VB_Name = "INI"
Option Explicit
'declare strucures for shell a notepad
Const STARTF_USEPOSITION = &H4
Const STARTF_USESIZE = &H2

Private Type STARTUPINFO
cb As Long
lpReserved As String
lpDesktop As String
lpTitle As String
dwX As Long
dwY As Long
dwXSize As Long
dwYSize As Long
dwXCountChars As Long
dwYCountChars As Long
dwFillAttribute As Long
dwFlags As Long
wShowWindow As Integer
cbReserved2 As Integer
lpReserved2 As Long
hStdInput As Long
hStdOutput As Long
hStdError As Long
End Type

Private Type PROCESS_INFORMATION
hProcess As Long
hThread As Long
dwProcessID As Long
dwThreadID As Long
End Type
Dim r As String ' r - general purpose string

' Set variables for ProgressBar Color
Public Const WM_USER = &H400
Public Const CCM_FIRST       As Long = &H2000&
Public Const CCM_SETBKCOLOR  As Long = (CCM_FIRST + 1)

'set progressbar barcolor in IE4 or later
Public Const PBM_SETBARCOLOR As Long = (WM_USER + 9)

Private Declare Function SendMessage Lib "user32" _
   Alias "SendMessageA" _
  (ByVal hwnd As Long, _
   ByVal wMsg As Long, _
   ByVal wParam As Long, _
   lParam As Any) As Long
' Win32 api to start a separate process
' used to launch notepad for viewing error file

Declare Function CreateProcessA Lib "kernel32" _
(ByVal lpApplicationName As Long, ByVal lpCommandLine As _
String, ByVal lpProcessAttributes As Long, ByVal _
lpThreadAttributes As Long, ByVal bInheritHandles As Long, _
ByVal dwCreationFlags As Long, ByVal lpEnvironment As Long, _
ByVal lpCurrentDirectory As Long, lpStartupInfo As _
STARTUPINFO, lpProcessInformation As PROCESS_INFORMATION) _
As Long

Declare Function ShellExecute Lib "shell32.dll" _
Alias "ShellExecuteA" ( _
ByVal hwnd As Long, _
ByVal lpOperation As String, _
ByVal lpFile As String, ByVal lpParameters As String, _
ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

Public Const SW_SHOWNORMAL As Long = 1
Public Const SW_SHOWMAXIMIZED As Long = 3
Public Const SW_SHOWDEFAULT As Long = 10
Private Const NORMAL_PRIORITY_CLASS = &H20&
Private Const INFINITE = -1&

'''
Private Declare Function ShowCursor Lib "user32" (ByVal bShow As Long) As Long

Public Enum CursorType
   Normal
   Busy
   HideIt
   ShowIt
End Enum

Private Const OCR_NORMAL = 32512

Public lngOldCursor As Long, lngNewCursor As Long

Private Declare Function LoadCursorFromFile Lib "user32" Alias _
    "LoadCursorFromFileA" (ByVal lpFileName As String) As Long
Private Declare Function SetSystemCursor Lib "user32" _
    (ByVal hcur As Long, ByVal id As Long) As Long
Private Declare Function GetCursor Lib "user32" () As Long
Private Declare Function CopyIcon Lib "user32" (ByVal hcur As Long) As Long
'''

Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, lpKeyName As Any, ByVal lpDefault As String, ByVal lpRetunedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long

Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lplFileName As String) As Long
Public Sub SetProgressBarColour(hwndProgBar As Long, ByVal clrref As Long)
   Call SendMessage(hwndProgBar, PBM_SETBARCOLOR, 0&, ByVal clrref)
End Sub
Public Sub ShellIt(cmdline$)
    Dim proc As PROCESS_INFORMATION
    Dim start As STARTUPINFO
    Dim ret&
    'Initialize the STARTUPINFO structure:
    start.cb = Len(start)
    start.dwFlags = STARTF_USESIZE Or STARTF_USEPOSITION
    ' play with the STATUP info structure like this:
    start.dwX = 200
    start.dwY = 400
    start.dwXSize = 500 'width
    start.dwYSize = 100 'height
    'Start the shelled application:
    ret& = CreateProcessA(0&, cmdline$, 0&, 0&, 1&, NORMAL_PRIORITY_CLASS, 0&, 0&, start, proc)
End Sub
Public Sub StartAnimatedCursor(AniFilePath As String)
    'Create a copy of the current cursor,
    'for Windows NT compatibility
    lngOldCursor = CopyIcon(GetCursor())
    'Check the passed string, if it contains
    'a solid file path, then load the cursor
    'from file. If not, add the App.Path,
    '*then* load cursor...
    If InStr(1, AniFilePath, "\") Then
        lngNewCursor = LoadCursorFromFile(AniFilePath)
    Else
        lngNewCursor = LoadCursorFromFile(App.Path & _
            "\" & AniFilePath)
    End If
    'Activate the cursor
    SetSystemCursor lngNewCursor, OCR_NORMAL
End Sub
Public Sub RestoreLastCursor()
    SetSystemCursor lngOldCursor, OCR_NORMAL
End Sub
Function BoolToStr(InBool As Boolean) As String
    If (InBool) Then BoolToStr = "1" Else BoolToStr = "0"
End Function
Function GetFromINI(Category As String, Parameter As String, FilePath As String) As String
    Dim n As String
    Dim File As String
    File = FilePath
    n = String(255, Chr(0))
    GetFromINI = Left(n, GetPrivateProfileString(Category, ByVal Parameter, "", n, Len(n), File)) 'set string value of GetFromINI
    If GetFromINI = "" Then
        GetFromINI = "N/A"
    End If
End Function
Function WriteToINI(Category As String, Parameter As String, Value As String, FilePath As String)
    Dim File As String
    Dim x As String
    File = FilePath
    r = WritePrivateProfileString(Category, Parameter, Value, File)
    If r <> 1 Then
        x = MsgBox("Error: Writing to INI file failed! Check the file path!" & File, vbCritical, "Error")
    End If
    WriteToINI = r
End Function
Public Function SetMouseCursor(Status As CursorType) As Boolean
    Select Case Status
       Case CursorType.Normal
          Screen.MousePointer = vbDefault
          SetMouseCursor = True
       Case CursorType.Busy
          Screen.MousePointer = vbHourglass
          SetMouseCursor = True
       Case CursorType.HideIt
          ShowCursor False
          SetMouseCursor = True
       Case CursorType.ShowIt
          ShowCursor True
          SetMouseCursor = True
       Case Else
          SetMouseCursor = False
    End Select
End Function
Public Function FormVoltageString(ModuleType As String) As String
    Dim Voltage As String
    Dim MinVoltage As String
    Dim MaxVoltage As String
    Dim scalefile As String
    MinVoltage = GetFromINI(ModuleType, "MinVoltage", scalefile)
    MaxVoltage = GetFromINI(ModuleType, "MaxVoltage", scalefile)
    Voltage = MinVoltage & " - " & MaxVoltage
    FormVoltageString = Voltage
End Function
Public Function RatedCurrent(ModuleType As String) As String
    Dim Current As String
    Dim scalefile As String
    Current = GetFromINI(ModuleType, "MaxCurrent", scalefile)
    RatedCurrent = Current
End Function


